/* Piezo Knock
 * -----------
 * Превратите стандартную пьезо-пищалку в датчик силы
 *
 * Created 24 October 2006
 * copyleft 2006 Tod E. Kurt <tod@todbot.com
 * http://todbot.com/
 */


int ledPin = 13;
int piezoPin = 2;

int THRESHOLD = 100;  // установить минимальную величину, которая 
		      // сигнализирует об ударе

int val = 0;       // переменная для хранения показания с сенсора
int t = 0;         // "время", измеряющее, как долго длится удар

void setup() {
  pinMode(ledPin, OUTPUT);
  Serial.begin(19200);
  Serial.println("ready");      // показать, что мы ждём
}

void loop() {
  digitalWrite(ledPin,LOW);     // показать, что мы ждём

  val = analogRead(piezoPin);   // считать сигнал с пьезоэлемента
  if( val > THRESHOLD ) {      // он больше, чем наш минимум?
    digitalWrite(ledPin, HIGH); // сказать об этом
    t = 0;
    while(analogRead(piezoPin) > THRESHOLD) {
      t++;
    } // подождать, пока не достигнет LOW  (с маленьким гистерезисом)
    if(t>100) {  // отрезать низкие значения, потому что это шум
      Serial.print("knock! ");
      Serial.println(t);
    }
  }
}
 
