/*
 * Serial Read Blink
 * -----------------
 * Включает и выключает светоизлучающий диод (LED), подключенный к цифровому  
 * пину 13. Светодиод будет мигать столько раз, сколько говорит ASCII-число 
 * из одной цифры, считанное из последовательного порта.
 *
 * Created 18 October 2006
 * copyleft 2006 Tod E. Kurt <tod@todbot.com>
 * http://todbot.com/
 * 
 * основан на примере "serial_read_advanced"
 */

int motorPin = 9;
int val = 0;       // переменная для хранения данных из последовательного порта

void setup() {
  pinMode(motorPin,OUTPUT);    // объявить пин мотора выходом
  Serial.begin(19200);        // подключиться к последовательному порту
  Serial.println("Welcome to SerialMotorSpeed!");
  Serial.println("Enter speed number 0-9:");
}

void loop () {
  val = Serial.read();      // прочитать значение с последовательного порта
  if (val >= '0' && val <= '9' ) {
    val = val - '0';       // перевести из символа в число
    val = 28 * val;        // перевести из 0-9 в 0-255 (почти)
    Serial.print("Setting speed to ");
    Serial.println(val);
    analogWrite(motorPin,val);
    
    Serial.println("Enter speed number 0-9:");
  }
}

